+++
title = "1001 Video Games You Must Play Before You Die - Tony Mott"
date = 2015-01-11

[taxonomies]
tags = ["books", "tony mott", "video games", "reviews", "2 stars"]
+++

[GoodReads Summary](https://www.goodreads.com/book/show/8390909-1001-video-games-you-must-play-before-you-die):
For devoted gamers as well as those interested in groundbreaking graphic
design, this is the first, most comprehensive, and only critical guide ever
published to video games. The video game has arrived as entertainment and as
an art form. This is the first serious critical evaluation ever published of
the best video games and is a testament to the medium’s innovativeness and
increasing emphasis on aesthetics. Organized chronologically and for all
platforms (PC, Xbox, PlayStation, etc.) and covering all genres from the bold
(Grand Theft Auto and Halo) and dark (Resident Evil and Silent Hill) to the
spiritual (Final Fantasy) and whimsical (Legend of Zelda), the book traces the
video game from the rough early days of Pong to the latest visual fantasia.

<!-- more -->

{{ stars(stars=2) }}

For a second -- or, at least, the first chapter --, you may believe that this
book will discuss 1001 games that influenced the next generation, from the
very first pong all the way to the latest Mario. Sadly, it doesn't.

The whole problem is that the authors decided to use a chronological order
instead of a topic order. Instead of going "this game introduced this feature"
and then jump to the next which improved that feature, they go into games
released in the 70s, 80s, 90s, 2000s and 2010s. "Where is the harm in that?"
you may ask. Well, the harm is that the chronological order doesn't offer,
most of the time, the reason *why* a game should be played. I mean, yeah,
maybe "Mario World" is not a bad game, but if "Mario World 2" just improves
the old mechanics and have bigger maps, it's clear why the first shouldn't be
in the list if everything from the first I can get in a better form in the
second.

For example, when they talk about "Ninja Gaiden Black", the authors mention
this:

> Barring a dodgy camera, Ninja Gaiden didn't have much wrong with it.  That
> didn't stop Team Ninja from obsessively tinkering with their masterprice,
> however, and in Ninja Gaiden Black they improved on what many fighting fans
> already regarded as the greatest fighting game of its generation."

And guess what? "Ninja Gaiden" is also in the list! Why would I play the first
one when the second is everything the first one has plus more?

Also, each game have three to four paragraphs. The first is always something
related to the game outside it: The company that developed it, some social
remark at the time, something in the game culture... anything that it is not
the game; the last paragraph try to conclude the (simplistic) review with a
positive note; the paragraphs in the middle, which should be the "Why" are not
always they "Why". Most of the Mario  and Zelda games simply lack the "why".
You should play because... you should play?

This is why I'd prefer a topic order: Mario 1 introduced this, Mario 2 changed
this into that... It basically forces the list to have a reason instead of
seemingly being a list of "I like it".

Also, research seems focused on "games I played" instead of "games that
existed". For example, there is "Trine", which I can't call a bad game, but
the mechanic of "you play several characters and just jump between them based
on their abilities" I can backtrack all the way to "Captain Trueno" on MSX in
1989 -- and I'm not claiming *that's* where this mechanics appeared -- but
omitting it seems too much laziness. "Master of Orion", "Dota" (the mod for
Warcraft III), "Tetrifast", "King's Valley", "Stunts"... all those are games
that I can, from my childhood, bring back as previous examples of some of the
recommended games that has the same mechanics and are not listed. But,
instead, games with the same mechanics but from bigger publishers are. There
is even a game I played on MSX in the 90s that have the *exactly* mechanic
listed in "Warioware Inc" but, again, not listed. Heck, even "bananas.bas",
part of the MS-DOS 6.0 as an example of how powerful QBasic could be, has the
same mechanics as "Death Tank", but the later is listed as some "brilliant
mechanic never seen before".

In the end, it seems much more like a list of "games that we, the authors
like" than a proper "these games you should play because they describe some
advancement in games technology and/or some social discussion about the times
when they were released", which turns this into a meaningless e-peen counting
(171, by the way).
