+++
title = "Films from the Future: The Technology and Morality of Sci-Fi Movies - Andrew Maynard"
date = 2018-11-29

category = "review"

[taxonomies]
tags = ["books", "andrew maynard", "movies", "scifi", "technology",
"philosophy", "4 stars"]
+++

[GoodReads summary](https://www.goodreads.com/book/show/41045578-films-from-the-future):
Science, technology, and society: In Films from the Future, former physicist
Andrew Maynard threads together his love of science fiction movies with his
expertise on emerging technologies to engage, entertain and make you think
about the relationship between technology, and society as they discover
astounding, transformative advances in science. Through the imagination and
creativity of science fiction movies, Maynard introduces readers to the
profound capabilities presented by new and emerging technologies, and the
complex personal and societal challenges they present.

<!-- more -->

{{ stars(stars=4) }}

Writing a review of this book is hard, 'cause all I have are some disconnected
options about it -- and, in a way, these opinions may only reflect the
disconnected points in the book.

So, first point: I find it weird to read a *book* about *movies*
which, in most part, are based on *books*>. One of the points, about Dan
Brown's "Inferno" even mentions that, as a ethics discussion, the book takes a
step further than the movie. Although the point of using movies was more of
"opening discussions using art", it seems weird not to use the books, which are
more rich and more intricate, to raise moral and ethical points.

Second point: Some movies seem just an excuse to discuss other things. For
example, "Transcendence" (which, against the first point, it is not based on a
book). Instead of giving real focus to nanotechnology -- and its ethical and
moral uses -- and focuses way too much on the Luddite part it, talking about
some real life counterparts and explaining their point of view and how it
affects science in general.

Third point: It is way too long. I mean, most of the subjects the author just
keeps dancing around the topic and don't move forward. "Transcendence" is,
again, a typical case: Yes, Luddites have some points, yes, maybe we shouldn't
listen to all the point, but the fact is, all the time, those two points keep
coming and going, for pages, without reaching a conclusion. At some point, I
was just reading the first half of the paragraphs 'cause I noticed the second
half would be repeated either in the first part of the next paragraph or just
the one following it.

But, on top of that, I guess the "Morality" part of the title may lead to some
confusion. It's not "you, random person reading this book, here are some
morality discussions about things you do"; it's way more as "we, scientists,
must have some moral discussions about what we are doing". It could clear the
air for "random persons reading the book" about how science -- and scientists
-- work, but still it is a discussion about morality with scientists.

And, in a way, it may also throw people into sciences, because it shows that
scientists are not just "let's find out what's here", but they are worried (or,
at least, as the book tries, should) about the moral repercussions of what they
are working on.
